#include <windows.h>
#include <math.h>
#include "stdio.h"
#include "conio.h"
#include "hextobin.h"
#include "resource.h"

//Include header and LIBs
#include "InfSmart.h"
#pragma comment( lib, "InfSmart.lib" )

#include "InfUnltd.h"
#pragma comment( lib, "InfUnltd.lib" )

unsigned char DEVICE = 0;

#define INFUNLTD 1
#define INFSMART 2

//Map IO functions to either InfSmart or InfUnltd
int SynchronousBegin(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousBegin(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousBegin(hDevice);

	return 1;
}

int SynchronousEnd(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousEnd(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousEnd(hDevice);

	return 1;
}

int SynchronousProcess(HANDLE hDevice, unsigned char iostate)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousProcess(hDevice,iostate);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousProcess(hDevice,iostate);

	return 1;
}

int SynchronousWriteCommand(HANDLE hDevice, unsigned char control, unsigned char adr, unsigned char data)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousWriteCommand(hDevice, control, adr, data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousWriteCommand(hDevice, control, adr, data);

	return 1;
}

int SynchronousWriteOneByteLSB(HANDLE hDevice, unsigned char data)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousWriteOneByteLSB(hDevice, data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousWriteOneByteLSB(hDevice, data);

	return 1;
}

int SynchronousWriteOneByteMSB(HANDLE hDevice, unsigned char data)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousWriteOneByteMSB(hDevice, data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousWriteOneByteMSB(hDevice, data);

	return 1;
}

int SynchronousCycleClock(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousCycleClock(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousCycleClock(hDevice);

	return 1;
}

int SynchronousRead8bit(HANDLE hDevice,unsigned char count, unsigned char* data)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousRead8bit(hDevice,count,data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousRead8bit(hDevice,count,data);

	return 1;
}

int SynchronousReadXbytesYbits(HANDLE hDevice,unsigned char bytecount, unsigned char bitcount, unsigned char* data)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousReadXbytesYbits(hDevice,bytecount, bitcount, data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousReadXbytesYbits(hDevice,bytecount, bitcount, data);

	return 1;
}

int SynchronousSetRST(HANDLE hDevice, unsigned char state)
{
	if(DEVICE == INFSMART)
		return INFSMART_SynchronousSetRST(hDevice, state);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_SynchronousSetRST(hDevice, state);

	return 1;
}

int IICClockOutStart(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICClockOutStart(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICClockOutStart(hDevice);

	return 1;
}

int IICClockOutStop(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICClockOutStop(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICClockOutStop(hDevice);

	return 1;
}

int IICClockOutByte(HANDLE hDevice, unsigned char data)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICClockOutByte(hDevice,data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICClockOutByte(hDevice,data);

	return 1;
}

int IICClockInByteAck(HANDLE hDevice, unsigned char *data)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICClockInByteAck(hDevice,data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICClockInByteAck(hDevice,data);

	return 1;
}

int IICClockInByteNack(HANDLE hDevice, unsigned char *data)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICClockInByteNack(hDevice,data);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICClockInByteNack(hDevice,data);

	return 1;
}

int IICCycleClock(HANDLE hDevice)
{
	if(DEVICE == INFSMART)
		return INFSMART_IICCycleClock(hDevice);
	else
	if(DEVICE == INFUNLTD)
		return INFUNLTD_IICCycleClock(hDevice);

	return 1;
}

HINSTANCE hInst = 0;
HWND m_MainDlg = 0;
INT_PTR CALLBACK MainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
HANDLE hDevice = 0;
bool bContinue = false;
bool Erase = false;

#define EEPROM_ADDRESS 0xA0
#define MAX_EEPROM_SIZE 1024*(1024/8)

HexToBin ohex;

int ReadMemory(HWND hDlg);
int WriteMemory(HWND hDlg);
int LoadFile(HWND hDlg);
int SaveFile(HWND hDlg);

int FileLoadResult = -1;

BOOL APIENTRY WinMain(HINSTANCE hinstCurrent,HINSTANCE hinstPrevious,LPSTR lpszCmdLine,int nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	hInst = hinstCurrent;

	m_MainDlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG1),0,(DLGPROC)MainDlgProc);

	ShowWindow(m_MainDlg,SW_SHOW);

	hAccelTable = LoadAccelerators(hinstCurrent, MAKEINTRESOURCE(IDC_DEMO_SLE4442));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	if(hDevice != 0)
	{
		SynchronousEnd(hDevice);

		if(DEVICE == INFUNLTD)
		INFUNLTD_CloseDevice(hDevice);
		else
		if(DEVICE == INFSMART)
		INFSMART_CloseDevice(hDevice);
	}

	return (int) msg.wParam;
}

int OnInitDialog(HWND hDlg)
{
	int status = 1;

	for(int l = 0; l < 11; l++)
	{
		char buf[255] = {0};

		unsigned int eep = pow(2.0,(int)l);
		sprintf(buf,"24C%.2d",eep);

		SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) buf);
	}

	SetWindowText(GetDlgItem(hDlg,IDC_EDIT1),"000000");

	SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,(WPARAM) 0,(LPARAM) 0);

	DWORD InfSmartDeviceCount = 0;

	INFSMART_GetNumDevices(&InfSmartDeviceCount);

	DWORD InfUnltdDeviceCount = 0;

	INFUNLTD_GetNumDevices(&InfUnltdDeviceCount);

	if(InfSmartDeviceCount > 0 && InfUnltdDeviceCount == 0)
	{
		status = INFSMART_OpenDeviceFromNum(0,&hDevice,0);
		DEVICE = INFSMART;
	}else
	if(InfSmartDeviceCount == 0 && InfUnltdDeviceCount > 0)
	{
		status = INFUNLTD_OpenDeviceFromNum(0,&hDevice,0);

		if(INFUNLTD_GetFirmwareVersion(hDevice) < 1050)
		{
			INFUNLTD_CloseDevice(hDevice);
			MessageBox(m_MainDlg,"Firmware version 1.05 required\n\nUpgrade using Infinity USB Unlimited software","Error",MB_OK);
			return 1;
		}

		INFUNLTD_SetTimeouts(2500,2500);

		DEVICE = INFUNLTD;
	}else
	if(InfSmartDeviceCount > 0 && InfUnltdDeviceCount > 0)
	{
		status = INFUNLTD_OpenDeviceFromNum(0,&hDevice,0);

		if(INFUNLTD_GetFirmwareVersion(hDevice) < 1050)
		{
			/*
			INFUNLTD_CloseDevice(hDevice);
			MessageBox(m_MainDlg,"Firmware version 1.05 required\n\nUpgrade using Infinity USB Unlimited software","Error",MB_OK);
			return 1;
			*/
			status = INFSMART_OpenDeviceFromNum(0,&hDevice,0);
			DEVICE = INFSMART;
			return status;
		}

		INFUNLTD_SetTimeouts(2500,2500);

		DEVICE = INFUNLTD;
	}
	else status = 1;

	return status;
}

bool SaveFile(HWND hwndDlg,LPTSTR lpszFile, LPTSTR lpszTitle)
{
	OPENFILENAME ofn;

	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hwndDlg;
	ofn.lpstrFilter = "EEprom image (*.bin)\0*.bin\0All Files (*.*)\0*.*\0\0";
	ofn.lpstrFile = lpszFile;
	ofn.lpstrTitle = lpszTitle;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrDefExt = "bin";
	ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	if(!GetSaveFileName(&ofn))
		return FALSE;

	return TRUE;
}

bool OpenFile(HWND hwndDlg,PTCHAR lpszFile,PTCHAR lpszDir, PTCHAR szTitle)
{
	OPENFILENAME ofn;

	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hwndDlg;

	ofn.lpstrFilter = "EEprom image (*.hex;*.bin)\0*.hex;*.bin;\0All Files (*.*)\0*.*\0\0";

	ofn.lpstrFile = lpszFile;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrDefExt = "bin";

	ofn.lpstrInitialDir = lpszDir;
	ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST;
	ofn.lpstrTitle = szTitle;

	if(!GetOpenFileName(&ofn)) return false;

	return true;
}

int OnWriteMemory(HWND hDlg)
{
	int status = 0;
	unsigned char Device = (unsigned char) SendMessage(GetDlgItem(hDlg,IDC_COMBO1),CB_GETCURSEL,0,0);
	unsigned int eep = pow(2.0,(int)Device);
	unsigned int EEpromSize = eep * 1024/8;
	const unsigned char PageSizes[11] = {8,8,16,16,16,32,32,64,64,128,128};
	char startadr[20];
	unsigned int start = 0;
	unsigned char PageSize = PageSizes[Device];
	unsigned int outputloop = 0;

	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Writing...");

	status = SynchronousBegin(hDevice);

	GetWindowText(GetDlgItem(hDlg,IDC_EDIT1),startadr,sizeof(startadr));
	//start = atoi(startadr);
	start = strtol(startadr,0,16);
	sprintf(startadr,"%.6X",start);
	SetWindowText(GetDlgItem(hDlg,IDC_EDIT1),startadr);
	
	//Test command: 3A 32 34A0 34003400 3401 3402 3403 3404 3405 3406 3407 3408 3409 340A 340B 340C 340D 340E 340F 3410 3411 33
	for(unsigned int loop = start; loop < EEpromSize; loop+=PageSize)
	{
		//Map the address to the Control byte + MSB address + LSB address
		unsigned char CTRLByte = 0;
		unsigned char MSBadr = 0;
		unsigned char LSBadr = 0;

		if (EEpromSize > 2048)
		{
			CTRLByte = ((EEPROM_ADDRESS & 0xFE) | (((loop) & 0x70000)>>15));
			MSBadr = ((loop)>>8) & 0xFF;
			LSBadr = (loop) & 0xFF;
		}else
		{
			CTRLByte = ((EEPROM_ADDRESS & 0xFE) | (((loop) & 0x700)>>7));
			MSBadr = ((loop)>>8) & 0xFF;
			LSBadr = (loop) & 0xFF;
		}

		//Setup address
		status = IICClockOutStart(hDevice);								//I2C Start condition
		status = IICClockOutByte(hDevice,CTRLByte);						//CONTROL BYTE WRITE
		if (EEpromSize > 2048)
		status = IICClockOutByte(hDevice,MSBadr);						//ADDRESS HIGH BYTE
		status = IICClockOutByte(hDevice,LSBadr);						//ADDRESS LOW BYTE

		//Do page write
		for(int loop2 = 0; loop2 < PageSize; loop2++)
		{
			if(Erase)
				status = IICClockOutByte(hDevice,0xFF);
			else
			status = IICClockOutByte(hDevice,ohex.OutputBin(outputloop++));
		}
		
		status = IICClockOutStop(hDevice);

		Sleep(5);	//5ms write time

		char buf[255] = {0};
		sprintf(buf,"Writing... %d %%",(unsigned int)(((float)((float)loop/(float)EEpromSize))*100.0));
		SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),buf);

		if(!bContinue)
			break;
	}

	status = SynchronousEnd(hDevice);

	EnableWindow(GetDlgItem(hDlg,IDCANCEL),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_COMBO1),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_LOAD),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_SAVE),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_WRITE),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_ERASE),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT1),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_READ),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_STOP),FALSE);

	if(bContinue)
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Done writing...");
	else SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Done writing (aborted)...");

	bContinue = false;

	return 0;
}

int OnReadMemory(HWND hDlg)
{
	int status = 0;
	unsigned char Device = (unsigned char) SendMessage(GetDlgItem(hDlg,IDC_COMBO1),CB_GETCURSEL,0,0);
	unsigned int eep = pow(2.0,(int)Device);
	unsigned int EEpromSize = eep * 1024/8;

	ohex.ClearBuffers(0xFF);

	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Reading...");

	status = SynchronousBegin(hDevice);

	//Test command: 3A32 34A0 34003400 32 34A1 36363636363636363636363636363636363636363636363636363636363636363636363636363636363633
	ohex.PrepareForBinInput(0,0);

	//Setup address
	status = IICClockOutStart(hDevice);								//I2C Start condition
	status = IICClockOutByte(hDevice,EEPROM_ADDRESS & 0xFE);		//CONTROL BYTE WRITE
	if (EEpromSize > 2048)
	status = IICClockOutByte(hDevice,0);							//ADDRESS HIGH BYTE
	status = IICClockOutByte(hDevice,0);							//ADDRESS LOW BYTE

	//Do sequential read
	status = IICClockOutStart(hDevice);								//I2C Start condition
	status = IICClockOutByte(hDevice,EEPROM_ADDRESS | 0x01);		//CONTROL BYTE READ

	for(unsigned int loop = 0; loop < EEpromSize; loop++)
	{
		unsigned char data;
		
		status = IICClockInByteAck(hDevice,&data);

		ohex.InputBin(data);

		char buf[255] = {0};
		sprintf(buf,"Reading... %d %%",(unsigned int)(((float)((float)loop/(float)EEpromSize))*100.0));
		if(loop % 100 == 0 || loop == EEpromSize-1)
		SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),buf);

 		if(!bContinue)
			break;
	}

	status = IICClockOutStop(hDevice);

	status = SynchronousEnd(hDevice);

	EnableWindow(GetDlgItem(hDlg,IDCANCEL),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_COMBO1),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_LOAD),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_SAVE),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_WRITE),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_ERASE),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT1),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_READ),TRUE);
	EnableWindow(GetDlgItem(hDlg,IDC_STOP),FALSE);

	if(bContinue)
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Done reading...");
	else SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Done reading (aborted)...");

	bContinue = false;

	return 0;
}

DWORD StartRead(HWND hDlg)
{
	DWORD dwThreadID;

	if(bContinue)
		return 0;

	bContinue = true;

	EnableWindow(GetDlgItem(hDlg,IDCANCEL),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_COMBO1),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_LOAD),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_SAVE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_WRITE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_ERASE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT1),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_READ),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STOP),TRUE);

	HANDLE hThread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)OnReadMemory,hDlg,0,&dwThreadID);

	return dwThreadID;
}

DWORD StartWrite(HWND hDlg)
{
	DWORD dwThreadID;

	if(bContinue)
		return 0;

	bContinue = true;

	EnableWindow(GetDlgItem(hDlg,IDCANCEL),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_COMBO1),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_LOAD),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_SAVE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_WRITE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_ERASE),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT1),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_READ),FALSE);
	EnableWindow(GetDlgItem(hDlg,IDC_STOP),TRUE);
	
	HANDLE hThread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)OnWriteMemory,hDlg,0,&dwThreadID);

	return dwThreadID;
}

INT_PTR CALLBACK MainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		{
			int res = OnInitDialog(hDlg);
			if(res == 0)
			{
				if(DEVICE == INFUNLTD)
				SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Connected to Infinity USB Unlimited");
				else
				if(DEVICE == INFSMART)
				SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Connected to Infinity USB Smart");

				EnableWindow(GetDlgItem(hDlg,IDC_LOAD),TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_READ),TRUE);
				EnableWindow(GetDlgItem(hDlg,IDC_ERASE),TRUE);
			}
			return (INT_PTR)TRUE;
		}

	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
			case CBN_SELCHANGE:
			{
				if(LOWORD(wParam)==IDC_COMBO1)
				{
				}
			}
			break;
		}
		
		switch(LOWORD(wParam))
		{
			case IDOK:
			{
				return (INT_PTR)TRUE;
				break;
			}
	
			case IDCANCEL:
			{
				PostQuitMessage(0);
				break;
			}

			case IDC_STOP:
				bContinue = false;
				break;

			case IDC_LOAD:
				{
					char szFile[2048] = {0};

					bool res = OpenFile(hDlg,szFile,"","EEprom file");
					if(!res)
						return -1;

					if(_stricmp(szFile+strlen(szFile)-4,".hex")==0)
					{
						FileLoadResult = ohex.ParseHex(szFile,0);
					}
					else
					if(_stricmp(szFile+strlen(szFile)-4,".bin")==0)
					{
						FileLoadResult = ohex.ParseBin(szFile,0);
					}else
					{
						FileLoadResult = 1;
					}

					if(FileLoadResult == 0)
					{
						char buf[255];
						sprintf(buf,"File loaded OK (%d bytes)",ohex.DataSize());
						SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO2),buf);

						EnableWindow(GetDlgItem(hDlg,IDC_SAVE),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDC_WRITE),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDC_ERASE),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT1),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDC_READ),TRUE);
						EnableWindow(GetDlgItem(hDlg,IDC_STOP),FALSE);
					}else
					{
						char buf[255];
						sprintf(buf,"File load error (Error = %d)",FileLoadResult);
						SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO2),buf);

						EnableWindow(GetDlgItem(hDlg,IDC_SAVE),FALSE);
						EnableWindow(GetDlgItem(hDlg,IDC_WRITE),FALSE);
						EnableWindow(GetDlgItem(hDlg,IDC_ERASE),FALSE);
						EnableWindow(GetDlgItem(hDlg,IDC_EDIT1),FALSE);
						EnableWindow(GetDlgItem(hDlg,IDC_READ),FALSE);
						EnableWindow(GetDlgItem(hDlg,IDC_STOP),FALSE);
					}
				}
				break;

			case IDC_SAVE:
				{
					char szFile[2048] = {0};

					if(SaveFile(hDlg,(LPTSTR)szFile,"Save EEprom image")) 
						ohex.SaveBin(szFile);
				}
				break;

			case IDC_WRITE:
				Erase = false;
				StartWrite(hDlg);
				break;

			case IDC_ERASE:
				SetWindowText(GetDlgItem(hDlg,IDC_EDIT1),"000000");
				Erase = true;
				StartWrite(hDlg);
				break;
			
			case IDC_READ:
				StartRead(hDlg);
				break;
		}
	break;

	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
