#pragma once

// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the INFSMART_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// INFSMART_SDK functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef INFSMART_EXPORTS
#define INFSMART_SDK __declspec(dllexport)
#else
#define INFSMART_SDK __declspec(dllimport)
#endif

typedef	int	SDK_STATUS;

#define		SDK_SUCCESS					0x00
#define		SDK_INVALID_HANDLE			0x01
#define		SDK_DEVICE_NOT_FOUND		0xFF
#define		SDK_READ_ERROR				0x02
#define		SDK_RX_QUEUE_NOT_READY		0x03
#define		SDK_WRITE_ERROR				0x04
#define		SDK_INVALID_PARAMETER		0x06
#define		SDK_INVALID_REQUEST_LENGTH	0x07
#define		SDK_DEVICE_IO_FAILED		0x08
#define		SDK_PHOENIX_NOT_ENABLED		0x60
#define		SDK_ALREADY_OPENED			0x09
#define		SDK_PARITY_ERROR			0x0A

#ifdef __cplusplus
extern "C" {
#endif

//General IO
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_GetNumDevices(LPDWORD lpdwNumDevices);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_OpenDeviceFromNum(DWORD dwDevice, HANDLE* hDevice, LPVOID lpDeviceString);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_CloseDevice(HANDLE hDevice);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_SetLEDState(HANDLE hDevice, unsigned int R, unsigned int G,unsigned int B, unsigned char PWMDuty, unsigned char PWMFrq, unsigned char Activity);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_GetCardState(HANDLE hDevice, LPDWORD lpdwCardState);
INFSMART_SDK	DWORD			_stdcall INFSMART_GetFirmwareVersion(HANDLE hDevice);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_Write(HANDLE hDevice, LPCVOID lpBuffer,DWORD nNumberOfBytesToWrite, LPDWORD lpdwBytesWritten);
INFSMART_SDK 	SDK_STATUS		_stdcall INFSMART_Read(HANDLE hDevice, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpdwBytesRead);
INFSMART_SDK	DWORD			_stdcall INFSMART_BytesInFifo(HANDLE hDevice);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_EmptyFifo(HANDLE hDevice);

//Phoenix
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_Phoenix_Write(HANDLE hDevice, LPCVOID lpBuffer,DWORD nNumberOfBytesToWrite, LPDWORD lpdwBytesWritten);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_Phoenix_Read(HANDLE hDevice, LPVOID lpBuffer,DWORD nNumberOfBytesToRead, LPDWORD lpdwBytesRead);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_Phoenix_Enable(HANDLE hDevice, unsigned int baud, unsigned int * ActualBaud, unsigned char stopbit, unsigned char parity, unsigned char databits, unsigned int dwFrq, unsigned int PhRunningFrq, bool updateonly);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_Phoenix_Disable(HANDLE hDevice);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_Phoenix_SetRST(HANDLE hDevice, unsigned int state);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_Phoenix_ResetCard(HANDLE hDevice);
INFSMART_SDK	DWORD			_stdcall INFSMART_Phoenix_BytesInFifo(HANDLE hDevice);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_Phoenix_EmptyFifo(HANDLE hDevice);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_Phoenix_Trap(HANDLE hDevice, unsigned char Delay, unsigned char Trapvalue);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_Phoenix_TrapDelay(HANDLE hDevice, unsigned char Delay, unsigned char Trapvalue, DWORD dwSleep);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_Phoenix_BreakTrap(HANDLE hDevice, unsigned char Delay, unsigned char Trapvalue);

//SLE
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_SynchronousBegin(HANDLE hDevice);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_SynchronousEnd(HANDLE hDevice);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_SynchronousProcess(HANDLE hDevice, unsigned char iostate);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_SynchronousWriteCommand(HANDLE hDevice, unsigned char control, unsigned char adr, unsigned char data);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_SynchronousWriteOneByteLSB(HANDLE hDevice, unsigned char data);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_SynchronousWriteOneByteMSB(HANDLE hDevice, unsigned char data);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_SynchronousCycleClock(HANDLE hDevice);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_SynchronousRead8bit(HANDLE hDevice,unsigned char count, unsigned char* data);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_SynchronousReadXbytesYbits(HANDLE hDevice,unsigned char bytecount, unsigned char bitcount, unsigned char* data);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_SynchronousSetRST(HANDLE hDevice, unsigned char state);

//i2c
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_IICClockOutStart(HANDLE hDevice);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_IICClockOutStop(HANDLE hDevice);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_IICClockOutByte(HANDLE hDevice, unsigned char data);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_IICClockInByteAck(HANDLE hDevice, unsigned char *data);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_IICClockInByteNack(HANDLE hDevice, unsigned char *data);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_IICCycleClock(HANDLE hDevice);

//DeviceChange
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_GetDeviceInfo(HANDLE hDevice, LPARAM lParam, char* pDeviceInfo, int maxinfosize);
INFSMART_SDK	SDK_STATUS		_stdcall INFSMART_RequestNotification(HWND hWnd);

#ifdef __cplusplus
}
#endif
