// Demo_SLE4442.cpp : Defines the entry point for the application.
//

#include <windows.h>
#include "stdio.h"
#include "conio.h"

#include "WBLoaderaes.h"

//Include header and LIBs
#include "InfSmart.h"
#pragma comment( lib, "InfSmart.lib" )

#define INFSMART 1
unsigned char DEVICE = 0;

HINSTANCE hInst = 0;
HWND m_MainDlg = 0;
INT_PTR CALLBACK MainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

HANDLE hDevice = 0;

bool CardReady = false;
DWORD dwCard = 0;
DWORD dwCardLast = 0;

BOOL APIENTRY WinMain(HINSTANCE hinstCurrent,HINSTANCE hinstPrevious,LPSTR lpszCmdLine,int nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	hInst = hinstCurrent;

	m_MainDlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG1),0,(DLGPROC)MainDlgProc);

	ShowWindow(m_MainDlg,SW_SHOW);

	hAccelTable = LoadAccelerators(hinstCurrent, MAKEINTRESOURCE(IDC_DEMO_SLE4442));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		if(hDevice)
		{
			INFSMART_GetCardState(hDevice,&dwCard);

			if(dwCard == 0 && dwCardLast == 1)
			{
				CardReady = false;
			}
			dwCardLast = dwCard;
		}
	}

	if(hDevice != 0)
	{
		INFSMART_Phoenix_Disable(hDevice);
		INFSMART_CloseDevice(hDevice);
		hDevice = 0;
	}

	return (int) msg.wParam;
}

unsigned char HexToChar(unsigned char MSB,unsigned char LSB)
{
	unsigned char Bin=0;

	if(LSB>=48 && LSB<=57) Bin=LSB-48;
    else if(LSB>= 65 && LSB<=70) Bin=LSB-55;
	else if(LSB>= 65 && LSB<=70) Bin=LSB-55;
	else if(LSB>= 97 && LSB<=102) Bin=LSB-87;

    if(MSB>=48 && MSB<=57) Bin+=(MSB-48)*16;
	else if(MSB>=65 && MSB<=70) Bin+=(MSB-55)*16;
	else if(MSB>= 97 && MSB<=102) Bin+=(MSB-87)*16;

	return Bin;
}

int InitCard()
{
	const unsigned char ATR[] = {0x3B, 'W', 'B', '-', 'L', 'o', 'a', 'd', 'e', 'r','1','1','3','A'};
	int result = 0;
	unsigned char atrread[255] = {0};

	CardReady = false;

	unsigned int iActualBaud;

	result = INFSMART_OpenDeviceFromNum(0,&hDevice,0);
	DEVICE = INFSMART;

	INFSMART_Phoenix_Enable(hDevice,9600,&iActualBaud,1,1,8,6000000,6000000,false);

	result = INFSMART_Phoenix_ResetCard(hDevice);

	Sleep(100);

	int atrlen = INFSMART_Phoenix_BytesInFifo(hDevice);
	
	DWORD dwRead = 0;
	result = INFSMART_Phoenix_Read(hDevice, atrread, atrlen, &dwRead);

	if(atrlen != sizeof(ATR))
	{
		INFSMART_Phoenix_Disable(hDevice);
		return 2;
	}

	for(int index = 0; index < sizeof(ATR); index++)
	if(atrread[index] != ATR[index])
	{
		INFSMART_Phoenix_Disable(hDevice);
		return 2;
	}

	CardReady = true;

	return 0;
}

int OnInitDialog(HWND hDlg)
{
	int status = 1;

	for(int l = 0; l < 4; l++)
	{
		char buf[255] = {0};

		sprintf(buf,"%d",l);

		SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) buf);
	}

	SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,(WPARAM) 0,(LPARAM) 0);

	DWORD InfSmartDeviceCount = 0;

	INFSMART_GetNumDevices(&InfSmartDeviceCount);

	if(InfSmartDeviceCount > 0)
	{
		if(InitCard() != 0)
		return 2;
		
		status = 0;
	}else
	{
		MessageBox(hDlg,"No Infinity USB Smart devices found, please connect device and try again","Error",MB_OK);

		status = 1;
	}

	return status;
}

unsigned short int CalcCRC16(unsigned char bytedata, unsigned short int oldCRCvalue)
{
	unsigned short int crc = oldCRCvalue;

	crc  = (unsigned char)(crc >> 8) | (crc << 8);
	crc ^= bytedata;
	crc ^= (unsigned char)(crc & 0xff) >> 4;
	crc ^= (crc << 8) << 4;
	crc ^= ((crc & 0xff) << 4) << 1;

	return crc;
}

int OnWriteMemory(HWND hDlg)
{
	if(!CardReady)
	{
		SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Initializing card");
		if(InitCard() != 0)
		{
			SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Error connecting to card");
			return 1;
		}
	}

	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Writing page");

	int sel = (int)SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,(WPARAM) 0,(LPARAM) 0);

	unsigned char WriteBuffer[100];
	char ReadBuffer[100] = {0};
	unsigned char FC = 0;
	DWORD dwWritten = 0;
	DWORD dwRead = 0;

	GetWindowText(GetDlgItem(hDlg,IDC_EDIT1),ReadBuffer,33);//16 bytes x2 + 0

	WriteBuffer[FC++] = 0x03; //Write block
	WriteBuffer[FC++] = 0x00; //block no.
	WriteBuffer[FC++] = sel; //block no.

	for(int l = 0; l < 16; l++)
	{
		WriteBuffer[FC++] = HexToChar(ReadBuffer[(l*2)+0],ReadBuffer[(l*2)+1]);
	}

	unsigned short int crc = 0xFFFF;

	for(unsigned int l = 0; l < 16; l++)
		crc = CalcCRC16(WriteBuffer[3 + l], crc);
	
	WriteBuffer[FC++] = crc>>8;
	WriteBuffer[FC++] = crc&0xFF;

	INFSMART_Phoenix_Write(hDevice,WriteBuffer,FC,&dwWritten);

	INFSMART_Phoenix_Read(hDevice,ReadBuffer,FC,&dwRead);//Read echo

	INFSMART_Phoenix_Read(hDevice,ReadBuffer,1,&dwRead);//Read data
		
	if(ReadBuffer[0] == 0x00)
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Done writing page");

	if(ReadBuffer[0] == 0x01)
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"CRC error Writing page");

	if(ReadBuffer[0] == 0x02)
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Error Writing page");

	return 0;
}

int OnWriteKey(HWND hDlg)
{
	if(!CardReady)
	{
		SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Initializing card");
		if(InitCard() != 0)
		{
			SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Error connecting to card");
			return 1;
		}
	}

	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Setting key");

	unsigned char WriteBuffer[100];
	char ReadBuffer[100] = {0};
	unsigned char FC = 0;
	DWORD dwWritten = 0;
	DWORD dwRead = 0;

	GetWindowText(GetDlgItem(hDlg,IDC_EDIT3),ReadBuffer,65);//32 bytes x2 + 0

	WriteBuffer[FC++] = 0x06; //Set AES 256 key

	unsigned short int CRCkey = 0xFFFF;
		
	for(int l = 0; l < 32; l++)
	{
		WriteBuffer[FC] = HexToChar(ReadBuffer[(l*2)+0],ReadBuffer[(l*2)+1]);
		CRCkey = CalcCRC16(WriteBuffer[FC], CRCkey);

		FC++;
	}

	WriteBuffer[FC++] = CRCkey>>8;
	WriteBuffer[FC++] = CRCkey&0xFF;

	INFSMART_Phoenix_Write(hDevice,WriteBuffer,FC,&dwWritten);
	INFSMART_Phoenix_Read(hDevice,ReadBuffer,FC,&dwRead);//Read echo

	INFSMART_Phoenix_Read(hDevice,ReadBuffer,1,&dwRead);//Read response

	if(ReadBuffer[0] != 0x00)
		SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"CRC Error setting key");
	else
	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Done setting key");

	return 0;
}

int OnReadMemory(HWND hDlg)
{
	if(!CardReady)
	{
		SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Initializing card");
		if(InitCard() != 0)
		{
			SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Error connecting to card");
			return 1;
		}
	}

	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Reading page");

	int sel = (int)SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,(WPARAM) 0,(LPARAM) 0);

	unsigned char WriteBuffer[100];
	unsigned char ReadBuffer[100];
	unsigned char FC = 0;
	DWORD dwWritten = 0;
	DWORD dwRead = 0;

	WriteBuffer[FC++] = 0x02; //Read block
	WriteBuffer[FC++] = 0x00; //block no.
	WriteBuffer[FC++] = sel; //block no.
	
	INFSMART_Phoenix_Write(hDevice,WriteBuffer,FC,&dwWritten);
	INFSMART_Phoenix_Read(hDevice,ReadBuffer,FC,&dwRead);//Read echo
	INFSMART_Phoenix_Read(hDevice,ReadBuffer,18,&dwRead);//Read data

	sprintf((char*)WriteBuffer,"%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X%.2X",ReadBuffer[0],ReadBuffer[1],ReadBuffer[2],ReadBuffer[3],ReadBuffer[4],ReadBuffer[5],ReadBuffer[6],ReadBuffer[7],ReadBuffer[8],ReadBuffer[9],ReadBuffer[10],ReadBuffer[11],ReadBuffer[12],ReadBuffer[13],ReadBuffer[14],ReadBuffer[15]);
	SetWindowText(GetDlgItem(hDlg,IDC_EDIT1),(char*)WriteBuffer);

	SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Done reading page");

	return 0;
}

INT_PTR CALLBACK MainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		{
			int res = OnInitDialog(hDlg);
			if(res == 0)
			{
				if(DEVICE == INFSMART)
				SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Connected to Infinity USB Smart");
			}else
			if(res == 2)
				SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Error connecting to card");
			else
			SetWindowText(GetDlgItem(hDlg,IDC_STATIC_INFO),"Error connecting to device");

			return (INT_PTR)TRUE;
		}

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
			case IDOK:
			{
				return (INT_PTR)TRUE;
				break;
			}
	
			case IDCANCEL:
			{
				PostQuitMessage(0);
				break;
			}

			case IDC_READ:
				OnReadMemory(hDlg);
				break;

			case IDC_WRITE:
				OnWriteMemory(hDlg);
				break;

			case IDC_WRITE2:
				OnWriteKey(hDlg);
				break;
		}
	break;

	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
