using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using INFUNLTD_SDK;

namespace csharp
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			StopPhoenixMode();
			INFUNLTD.CloseDevice();

			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button3 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(8, 16);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(120, 23);
			this.button1.TabIndex = 0;
			this.button1.Text = "Enter phoenix mode";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Enabled = false;
			this.button2.Location = new System.Drawing.Point(144, 16);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(120, 23);
			this.button2.TabIndex = 1;
			this.button2.Text = "Exit phoenix mode";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(8, 56);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(176, 20);
			this.textBox1.TabIndex = 2;
			this.textBox1.Text = "";
			// 
			// button3
			// 
			this.button3.Enabled = false;
			this.button3.Location = new System.Drawing.Point(192, 56);
			this.button3.Name = "button3";
			this.button3.TabIndex = 4;
			this.button3.Text = "Reset Card";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(272, 85);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Infinity USB Unlimited C# example";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			int iNumDevices = 0;
			int status = 0;
			int iSDKVersion = 0;
			int iDevice = 0;
			byte[] DeviceString = new byte[255];

			//Initialize communications
			iSDKVersion = INFUNLTD.GetSDKVersion();

			INFUNLTD.GetNumDevices(ref iNumDevices);
			if(iNumDevices <= 0) return;

			status = INFUNLTD.OpenDeviceFromNum(iDevice,DeviceString);
			if(status != 0) return;
			//The INFUNLTD.CloseDevice(); is placed in Dispose();

			INFUNLTD.SetTimeouts(2000,2000);
			
			//Read the default LED setting
			INFUNLTD.ReadLED();
		}

		private void StartPhoenixMode()
		{
			int status = 0;
			int iNewCardState = 0;

			//Start phoenix mode at 9600baud @ 3579000Hz, and enable LED
			status = INFUNLTD.Phoenix_Enable(1,2);
			status = INFUNLTD.Phoenix_SetFrequency(3579000);
			status = INFUNLTD.SetLEDState(INFUNLTD.LED.LED_VCP_OPENED);
			status = INFUNLTD.SetLEDState(INFUNLTD.LED.LED_VCP_ACTIVITY_ON);

			//Read card switch
			status = INFUNLTD.GetCardState(ref iNewCardState);

			//If card in either slot
			if(iNewCardState == 1 || iNewCardState == 2)
			ResetAndReadATR();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			StartPhoenixMode();

			this.button1.Enabled = false;
			this.button2.Enabled = true;
			this.button3.Enabled = true;
		}

		private void StopPhoenixMode()
		{
			int status = 0;

			//Stop phoenix mode and set LED to user default
			status = INFUNLTD.Phoenix_Disable();
			status = INFUNLTD.Phoenix_SetFrequency(0);
			status = INFUNLTD.SetLEDState(INFUNLTD.LED.LED_VCP_CLOSED);
			status = INFUNLTD.SetLEDState(INFUNLTD.LED.LED_VCP_ACTIVITY_OFF);
			status = INFUNLTD.SetLEDState(INFUNLTD.LED.LED_USER);
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			StopPhoenixMode();

			this.button1.Enabled = true;
			this.button2.Enabled = false;
			this.button3.Enabled = false;
		}

		private void ResetAndReadATR()
		{
			int status = 0;
			int BytesRead = 0;
			int ATRLen = 0;
			byte[] ATR = new byte[255];

			//Reset card and read ATR
			status = INFUNLTD.Phoenix_ResetCard();

			//Wait for ATR to arrive
			System.Threading.Thread.Sleep(500);

			ATRLen = INFUNLTD.Phoenix_BytesInFifo();
			status = INFUNLTD.Phoenix_Read(ATR,ATRLen,ref BytesRead);

			if(BytesRead < 1)
				this.textBox1.Text = "Error reading ATR";
			else this.textBox1.Text = "ATR = " + System.Text.Encoding.ASCII.GetString(ATR);
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			this.textBox1.Text = "Resetting card...";
			this.Update();

			ResetAndReadATR();
		}
	}
}
