using System;
using System.Runtime.InteropServices;

namespace INFUNLTD_SDK
{
	/// <summary>
	/// Summary description for INFUNLTD_SDK.
	/// INFUNLTD SDK 2.07
	/// </summary>
	public class INFUNLTD
	{
		[Flags] public enum LED : byte
		{
			LED_USER					= 1,
			LED_VCP_CLOSED				= 8, 
			LED_VCP_OPENED				= 9, 
			LED_VCP_ACTIVITY_ON			= 10,
			LED_VCP_ACTIVITY_OFF		= 11
		}

		public static UInt16 LED_R_ENDSTATE = 0;
		public static UInt16 LED_G_ENDSTATE = 0;
		public static UInt16 LED_B_ENDSTATE = 0;

		#region DLL Imports

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_GetNumDevices",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_GetNumDevices(ref int lpdwNumDevices);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_OpenDeviceFromNum",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		//static extern int INFUNLTD_OpenDeviceFromNum(int dwDevice, ref IntPtr hDevice, [MarshalAs(UnmanagedType.LPStr)] string lpDeviceString);
			static extern int INFUNLTD_OpenDeviceFromNum(int dwDevice, ref IntPtr hDevice, byte[] lpDeviceString);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_CloseDevice",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_CloseDevice(IntPtr hDevice);
		
		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_SetLEDState",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_SetLEDState(IntPtr hDevice, UInt16 R, UInt16 G, UInt16 B, Byte PWMFrq);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_GetCardState",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_GetCardState(IntPtr hDevice, ref int lpdwCardState);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_GetFirmwareVersion",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_GetFirmwareVersion(IntPtr hDevice);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_GetSDKVersion",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_GetSDKVersion();

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_SetVoltage",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_SetVoltage(IntPtr hDevice, int dwVolt);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Write",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Write(IntPtr hDevice, byte[] buffer, int nNumberOfBytesToWrite, ref int lpdwBytesWritten);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Read",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Read(IntPtr hDevice, byte[] buffer, int nNumberOfBytesToRead, ref int lpdwBytesRead);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_SetTimeouts",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_SetTimeouts(int dwRead, int dwWrite);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_BytesInFifo",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_BytesInFifo(IntPtr hDevice);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_EmptyFifo",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_EmptyFifo(IntPtr hDevice);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_Write",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_Write(IntPtr hDevice, byte[] buffer, int nNumberOfBytesToWrite, ref int lpdwBytesWritten);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_Read",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_Read(IntPtr hDevice, byte[] buffer, int nNumberOfBytesToRead, ref int lpdwBytesRead);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_Enable",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_Enable(IntPtr hDevice, UInt16 baud, UInt16 stopbitparity);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_Change",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_Change(IntPtr hDevice, UInt16 baud, UInt16 stopbitparity);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_ChangeCustomBaud",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_ChangeCustomBaud(IntPtr hDevice, UInt16 custombaud, ref UInt16 actualbaud,UInt16 stopbitparity);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_SetFrequency",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_SetFrequency(IntPtr hDevice, int dwFrq);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_Disable",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_Disable(IntPtr hDevice);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_SetRST",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_SetRST(IntPtr hDevice, UInt16 state);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_ResetCard",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_ResetCard(IntPtr hDevice);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_BytesInFifo",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_BytesInFifo(IntPtr hDevice);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_EmptyFifo",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_EmptyFifo(IntPtr hDevice);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_Trap",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_Trap(IntPtr hDevice, Byte Delay, byte TrapValue);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_TrapDelay",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_TrapDelay(IntPtr hDevice, Byte Delay, byte TrapValue, int dwSleep);

		[DllImport("infunltd.dll", EntryPoint="INFUNLTD_Phoenix_BreakTrap",
			 ExactSpelling=true,CallingConvention=CallingConvention.StdCall)]
		static extern int INFUNLTD_Phoenix_BreakTrap(IntPtr hDevice, Byte Delay, byte TrapValue);

		#endregion

		#region DLLInterface

		public static IntPtr hDevice;
		public static int iDeviceOpened = 0;

		/// <summary>
		/// Returns the number of connected devices
		/// </summary>
		/// <param name="iNumDevices"></param>
		/// <returns></returns>
		static public int GetNumDevices(ref int iNumDevices)
		{
			return INFUNLTD_GetNumDevices(ref iNumDevices);
		}

		/// <summary>
		/// Opens the selected device and returns a handle to the device.
		/// </summary>
		/// <param name="iDevice"></param>
		/// <param name="hDevice"></param>
		/// <param name="DeviceString"></param>
		/// <returns></returns>
		static public int OpenDeviceFromNum(int iDevice, byte[] DeviceString)
		{
			iDeviceOpened = iDevice;
			return INFUNLTD_OpenDeviceFromNum(iDevice, ref hDevice, DeviceString);
		}

		/// <summary>
		/// Close a device previously opened by OpenDeviceFromNum()
		/// </summary>
		/// <returns></returns>
		static public int CloseDevice()
		{
			return INFUNLTD_CloseDevice(hDevice);
		}

		/// <summary>
		/// Sets the state of the RGB led in the programmer
		/// </summary>
		/// <param name="R"></param>
		/// <param name="G"></param>
		/// <param name="B"></param>
		/// <param name="PWMFrq"></param>
		/// <returns></returns>
		static public int SetLEDState(UInt16 R, UInt16 G, UInt16 B, Byte PWMFrq)
		{
			return INFUNLTD_SetLEDState(hDevice, R, G, B, PWMFrq);
		}
		
		static public int SetLEDState(LED state)
		{
			int status = 0;

			byte frq = 0;
			UInt16 Rduty = 0;
			UInt16 Gduty = 0;
			UInt16 Bduty = 0;

			switch(state)
			{
				case LED.LED_USER://1
					Rduty = LED_R_ENDSTATE;
					Gduty = LED_G_ENDSTATE;
					Bduty = LED_B_ENDSTATE;
					frq = 0xFF;

					status = INFUNLTD_SetLEDState(hDevice, Rduty, Gduty, Bduty, frq);
					break;

				case LED.LED_VCP_CLOSED://8
					Rduty = 0x2F00;
					Gduty = 0x0600;
					Bduty = 0x0600;
					frq = 0xFF;

					status = INFUNLTD_SetLEDState(hDevice, Rduty, Gduty, Bduty, frq);
					break;

				case LED.LED_VCP_OPENED://9
					Rduty = 0x7F00;
					Gduty = 0x1200;
					Bduty = 0x1200;
					frq = 0xFF;

					status = INFUNLTD_SetLEDState(hDevice, Rduty, Gduty, Bduty, frq);
					break;

				case LED.LED_VCP_ACTIVITY_ON:
					{
						byte[] buf = new byte[3];
						int iWritten = 0;
						
						buf[0] = 0x5E;
						buf[1] = 0x03;
						buf[2] = 0x01;

						status = Write(buf,3,ref iWritten);
					}
					break;		

				case LED.LED_VCP_ACTIVITY_OFF:
					{
						byte[] buf = new byte[3];
						int iWritten = 0;
							
						buf[0] = 0x5E;
						buf[1] = 0x03;
						buf[2] = 0x00;

						status = Write(buf,3,ref iWritten);
					}
					break;		

			}

			return status;
		}

		static public int GetCardState(ref int iCardState)
		{
			return INFUNLTD_GetCardState(hDevice, ref iCardState);
		}
		
		static public int GetFirmwareVersion()
		{
			return INFUNLTD_GetFirmwareVersion(hDevice);
		}
		
		static public int GetSDKVersion()
		{
			return INFUNLTD_GetSDKVersion();
		}

		static public int SetVoltage(int iVolt)
		{
			return INFUNLTD_SetVoltage(hDevice, iVolt);
		}
		
		static public int Write(byte[] buffer, int iBytesToWrite, ref int iBytesWritten)
		{
			return INFUNLTD_Write(hDevice, buffer, iBytesToWrite, ref iBytesWritten);
		}
		
		static public int Read(byte[] buffer, int iBytesToRead, ref int iBytesRead)
		{
			return INFUNLTD_Read(hDevice, buffer, iBytesToRead, ref iBytesRead);
		}

		static public int SetTimeouts(int iRead, int iWrite)
		{
			return INFUNLTD_SetTimeouts(iRead, iWrite);
		}
		
		static public int BytesInFifo()
		{
			return INFUNLTD_BytesInFifo(hDevice);
		}

		static public int EmptyFifo()
		{
			return INFUNLTD_EmptyFifo(hDevice);
		}
	
		static public int Phoenix_Write(byte[] buffer, int iBytesToWrite, ref int iBytesWritten)
		{
			return INFUNLTD_Phoenix_Write(hDevice, buffer, iBytesToWrite, ref iBytesWritten);
		}

		static public int Phoenix_Read(byte[] buffer, int iBytesToRead, ref int iBytesRead)
		{
			return INFUNLTD_Phoenix_Read(hDevice, buffer, iBytesToRead, ref iBytesRead);
		}

		static public int Phoenix_Enable(UInt16 baud, UInt16 stopbitparity)
		{
			return INFUNLTD_Phoenix_Enable(hDevice, baud, stopbitparity);
		}

		static public int Phoenix_Change(UInt16 baud, UInt16 stopbitparity)
		{
			return INFUNLTD_Phoenix_Change(hDevice, baud, stopbitparity);
		}

		static public int Phoenix_ChangeCustomBaud(UInt16 custombaud, ref UInt16 actualbaud,UInt16 stopbitparity)
		{
			return INFUNLTD_Phoenix_ChangeCustomBaud(hDevice, custombaud, ref actualbaud, stopbitparity);
		}

		static public int Phoenix_SetFrequency(int iFrq)
		{
			return INFUNLTD_Phoenix_SetFrequency(hDevice, iFrq);
		}

		static public int Phoenix_Disable()
		{
			return INFUNLTD_Phoenix_Disable(hDevice);
		}
		
		static public int Phoenix_SetRST(UInt16 state)
		{
			return INFUNLTD_Phoenix_SetRST(hDevice, state);
		}

		static public int Phoenix_ResetCard()
		{
			return INFUNLTD_Phoenix_ResetCard(hDevice);
		}
		
		static public int Phoenix_BytesInFifo()
		{
			return INFUNLTD_Phoenix_BytesInFifo(hDevice);
		}
		
		static public int Phoenix_EmptyFifo()
		{
			return INFUNLTD_Phoenix_EmptyFifo(hDevice);
		}

		static public int Phoenix_Trap(Byte Delay, byte TrapValue)
		{
			return INFUNLTD_Phoenix_Trap(hDevice, Delay, TrapValue);
		}

		static public int Phoenix_TrapDelay(Byte Delay, byte TrapValue, int iSleep)
		{
			return INFUNLTD_Phoenix_TrapDelay(hDevice, Delay, TrapValue, iSleep);
		}

		static public int Phoenix_BreakTrap(Byte Delay, byte TrapValue)
		{
			return INFUNLTD_Phoenix_BreakTrap(hDevice, Delay, TrapValue);
		}

		static public int ReadLED()
		{
			LED_R_ENDSTATE = ReadI2C(0xA1,0x1);
			LED_R_ENDSTATE <<= 8;
			LED_R_ENDSTATE |= ReadI2C(0xA1,0x00);

			LED_G_ENDSTATE = ReadI2C(0xA1,0x03);
			LED_G_ENDSTATE <<= 8;
			LED_G_ENDSTATE |= ReadI2C(0xA1,0x02);

			LED_B_ENDSTATE = ReadI2C(0xA1,0x05);
			LED_B_ENDSTATE <<= 8;
			LED_B_ENDSTATE |= ReadI2C(0xA1,0x04);

			return 0;
		}

		static private byte ReadI2C(byte I2Cctrl,byte Adr)
		{
			byte[] cBuf = new byte[10];
			byte[] ReadBuffer = new byte[10];
			int dwBytesWritten = 0;
			int dwRead = 0;

			cBuf[0]=0x4D;
			cBuf[1]=I2Cctrl;
			cBuf[2]=Adr;

			Write(cBuf,3,ref dwBytesWritten);
			if(dwBytesWritten<3) return 0;

			Read(ReadBuffer,1,ref dwRead);
			if(dwRead==1) return ReadBuffer[0];

			return 0xFF;
		}
		#endregion
	}
}
